#include <stdio.h>
#include <stdlib.h>

#include "f2c.h"

/* Common Block Declarations */

struct {
    double ay1[14], ay2[14], av1[13], av2[13], aw1[12], aw2[12], ya[2],
	    va[2], ina[2];
} first_;

#define first_1 first_

struct {
    double by1[14], by2[14], bv1[13], bv2[13], bw1[12], bw2[12], yb[2],
	    vb[2], inb[2];
} second_;

#define second_1 second_

 int main(void)
{
    /* System generated locals */
    int i__1, i__2;

    /* Builtin functions */
    double cos(double), sin(double);

    /* Local variables */
    extern int f_c();
    static double h__;
    static int j, m;
    static double q, y[2], h0;
    static int k0;
    static double x1, dy[2], xk, xn, yn[2], yt[2];
    static int kp1, kp2, kp3;
    static double rab[535], dyn[2], dyt[2];
    extern int de89d_c( );
    static double dely[2];
    static int imax;
    static double deldy[2];
    extern int f2trea_c();
    static int iniapr;

/*    AY1 - CHEBYSHEV COEFFICIENTS FOR 1 COORDINATE AT 1 INTERVAL */
/*    AY2 - CHEBYSHEV COEFFICIENTS FOR 2 COORDINATE AT 1 INTERVAL */

/*    AV1 - CHEBYSHEV COEFFICIENTS FOR 1 VELOCITY COMPONENT AT 1 INTERVAL */
/*    AV2 - CHEBYSHEV COEFFICIENTS FOR 2 VELOCITY COMPONENT AT 1 INTERVAL */

/*    AW1 - CHEBYSHEV COEFFICIENTS FOR 1 ACCELERATION COMPONENT AT 1 INTERVAL */
/*    AW2 - CHEBYSHEV COEFFICIENTS FOR 2 ACCELERATION COMPONENT AT 1 INTERVAL */

/*    BY1 - CHEBYSHEV COEFFICIENTS FOR 1 COORDINATE AT 2 INTERVAL */
/*    BY2 - CHEBYSHEV COEFFICIENTS FOR 2 COORDINATE AT 2 INTERVAL */

/*    BV1 - CHEBYSHEV COEFFICIENTS FOR 1 VELOCITY COMPONENT AT 2 INTERVAL */
/*    BV2 - CHEBYSHEV COEFFICIENTS FOR 2 VELOCITY COMPONENT AT 2 INTERVAL */

/*    BW1 - CHEBYSHEV COEFFICIENTS FOR 1 ACCELERATION COMPONENT AT 2 INTERVAL */
/*    BW2 - CHEBYSHEV COEFFICIENTS FOR 2 ACCELERATION COMPONENT AT 2 INTERVAL */

/*     YA - COORDINATES AT THE END OF 1 INTERVAL */
/*     VA - VELOCITY    AT THE END OF 1 INTERVAL */
/*     YB - COORDINATES AT THE END OF 2 INTERVAL */
/*     VB - VELOCITY    AT THE END OF 2 INTERVAL */

/*    INA - BOUNDARIES OF 1 INTERVAL */
/*    INB - BOUNDARIES OF 2 INTERVAL */

    m = 2;
    q = .5;
    xn = 0.f;
    yn[0] = cos(q) + 3.;
    yn[1] = -sin(q) + 2.;
    dyn[0] = q * 2. * sin(q);
    dyn[1] = q * 2. * cos(q);
    xk = 1.;
    h0 = .5;
    x1 = xk * 2. - 1.;
    yt[0] = cos(q * x1) + 3.;
    yt[1] = sin(q * x1) + 2.;
    dyt[0] = q * -2. * sin(q * x1);
    dyt[1] = q * 2. * cos(q * x1);
    k0 = 11;
    imax = 13;
    iniapr = 1;
    h__ = h0;

    de89d_c((U_fp)f_c, (U_fp)f2trea_c, &m, &xn, yn, dyn, &xk, &k0, &iniapr,
             &imax, &h__, y, dy, rab);

    dely[0] = yt[0] - y[0];
    dely[1] = yt[1] - y[1];
    deldy[0] = dyt[0] - dy[0];
    deldy[1] = dyt[1] - dy[1];

    printf("\n ------------------------------------------------------------\n");

    printf("\n h0=%21.14e k0=%3i iniapr= %1i imax=%3i \n\n",h0,k0,iniapr,imax);

    printf("\n y= %21.14e %21.14e\n", y[0], y[1]);
    printf("\n yt= %21.14e %21.14e\n",yt[0], yt[1]);
    printf("\n dely= %23.14e %21.14e\n\n", dely[0], dely[1]);

    printf("\n dy= %21.14e %21.14e\n",dy[0], dy[1]);
    printf("\n dyt= %21.14e %21.14e\n",dyt[0], dyt[1]);
    printf("\n deldy= %23.14e %21.14e \n", deldy[0], deldy[1]);

    printf("\n ***********************************************************\n");

    kp1 = 12;
    kp2 = 13;
    kp3 = 14;

    printf("\n CHEBYSHEV COEFFICIENTS  AT 1 SEGMENT" );

    printf("\n\n INA= %21.14e %21.14e\n", first_1.ina[0], first_1.ina[1]);

    printf("\n\n COORDINATES AND VELOCITY AT THE END OF 1 SEGMENT" );

    printf("\n\n YA= %21.14e %21.14e\n", first_1.ya[0], first_1.ya[1]);
    printf("\n VA= %21.14e %21.14e\n", first_1.va[0], first_1.va[1]);

    printf("\n\n              Coefficients for 1 component ");
    printf("\n\n         coordinate            velocity               acceleration\n ");

    i__1 = kp1;
    for (j = 1; j <= i__1; ++j) {
	i__2 = j - 1;

    printf("\n %i %22.14e %22.14e %22.14e", i__2, first_1.ay1[j -1], first_1.av1[j-1], first_1.aw1[j - 1]);
    }
    printf("\n %i %22.14e %22.14e ", kp1, first_1.ay1[kp2 -1], first_1.av1[kp2-1]);
    printf("\n %i %22.14e \n", kp2, first_1.ay1[kp3 -1]);

    printf("\n\n                       Coefficients for 2 component ");
    printf("\n\n           coordinate            velocity               acceleration\n ");

    i__2 = kp1;
    for (j = 1; j <= i__2; ++j) {
	i__1 = j - 1;

    printf("\n %i %22.14e %22.14e %22.14e ", i__1, first_1.ay2[j -1], first_1.av2[j-1], first_1.aw2[j - 1]);
    }
    printf("\n %i %22.14e %22.14e ", kp1, first_1.ay2[kp2 -1], first_1.av2[kp2-1]);
    printf("\n %i %22.14e ", kp2, first_1.ay2[kp3 -1]);
    printf("\n ");

    printf("\n CHEBYSHEV COEFFICIENTS  AT 2 SEGMENT" );
    printf("\n\n INB= %21.14e %21.14e\n", second_1.inb[0], second_1.inb[1]);

    printf("\n\n COORDINATES AND VELOCITY AT THE END OF 2 SEGMENT" );

    printf("\n\n YB= %21.14e %21.14e\n", second_1.yb[0], second_1.yb[1]);
    printf("\n VB= %21.14e %21.14e\n", second_1.vb[0], second_1.vb[1]);


    printf("\n\n                       Coefficients for 1 component ");
    printf("\n\n           coordinate            velocity               acceleration\n ");

    i__1 = kp1;
    for (j = 1; j <= i__1; ++j) {
	i__2 = j - 1;

    printf("\n %i %22.14e %22.14e %22.14e ", i__2, second_1.by1[j - 1], second_1.bv1[j - 1], second_1.bw1[j - 1]);
    }
    printf("\n %i %22.14e %22.14e ", kp1, second_1.by1[kp2 - 1], second_1.bv1[kp2 - 1]);
    printf("\n %i %22.14e \n", kp2, second_1.by1[kp3 - 1]);

    printf("\n\n                       Coefficients for 2 component ");
    printf("\n\n           coordinate            velocity               acceleration\n ");

    i__2 = kp1;
    for (j = 1; j <= i__2; ++j) {
	i__1 = j - 1;
    printf("\n %i %22.14e %22.14e %22.14e ", i__1, second_1.by2[j - 1], second_1.bv2[j - 1], second_1.bw2[j - 1]);
    }
    printf("\n %i %22.14e %22.14e ", kp1, second_1.by2[kp2 - 1], second_1.by2[kp2 - 1]);
    printf("\n %i %22.14e ", kp2, second_1.by2[kp3 - 1]);
    printf("\n ");
    return 0;
} /* main */

/* Subroutine */ int f_c(double *x, double *y, double *dy,
	double *z__, int *m)
{
    /* System generated locals */
    double d__1;

    /* Builtin functions */
    double exp(double);

    /* Local variables */
    static real q;

    /* Parameter adjustments */
    --z__;
    --dy;
    --y;

    /* Function Body */
    q = .5f;
/* Computing 2nd power */
    d__1 = (1. - exp(3. - y[1] + dy[2] * .5 / q)) / (*x + 1.);
    z__[1] = q * -2. * dy[2] - d__1 * d__1;
/* Computing 2nd power */
    d__1 = dy[2] - q * 2. * (y[1] - 3.);
    z__[2] = q * 2. * dy[1] - d__1 * d__1;
    return 0;
} /* f_c */


 int f2trea_c(int *s, double *xi, double *xe,
	double *y, double *dy, double *ay, double *ady,
	double *ad2y, int *m, int *kp1, int *kp2, int *kp3)
{
    /* System generated locals */
    int ay_dim1, ay_offset, ady_dim1, ady_offset, ad2y_dim1, ad2y_offset,
	    i__1;

    /* Local variables */
    static int i__;

/*    AY1 - CHEBYSHEV COEFFICIENTS FOR 1 COORDINATE AT 1 INTERVAL */
/*    AY2 - CHEBYSHEV COEFFICIENTS FOR 2 COORDINATE AT 1 INTERVAL */

/*    AV1 - CHEBYSHEV COEFFICIENTS FOR 1 VELOCITY COMPONENT AT 1 INTERVAL */
/*    AV2 - CHEBYSHEV COEFFICIENTS FOR 2 VELOCITY COMPONENT AT 1 INTERVAL */

/*    AW1 - CHEBYSHEV COEFFICIENTS FOR 1 ACCELERATION COMPONENT AT 1 INTERVAL */
/*    AW2 - CHEBYSHEV COEFFICIENTS FOR 2 ACCELERATION COMPONENT AT 1 INTERVAL */

/*    BY1 - CHEBYSHEV COEFFICIENTS FOR 1 COORDINATE AT 2 INTERVAL */
/*    BY2 - CHEBYSHEV COEFFICIENTS FOR 2 COORDINATE AT 2 INTERVAL */

/*    BV1 - CHEBYSHEV COEFFICIENTS FOR 1 VELOCITY COMPONENT AT 2 INTERVAL */
/*    BV2 - CHEBYSHEV COEFFICIENTS FOR 2 VELOCITY COMPONENT AT 2 INTERVAL */

/*    BW1 - CHEBYSHEV COEFFICIENTS FOR 1 ACCELERATION COMPONENT AT 2 INTERVAL */
/*    BW2 - CHEBYSHEV COEFFICIENTS FOR 2 ACCELERATION COMPONENT AT 2 INTERVAL */

/*     YA - COORDINATES AT THE END OF 1 INTERVAL */
/*     VA - VELOCITY    AT THE END OF 1 INTERVAL */

/*     YB - COORDINATES AT THE END OF 2 INTERVAL */
/*     VB - VELOCITY    AT THE END OF 2 INTERVAL */

/*    INA - BOUNDARIES OF 1 INTERVAL */
/*    INB - BOUNDARIES OF 2 INTERVAL */

    /* Parameter adjustments */
    --dy;
    --y;
    ad2y_dim1 = *m;
    ad2y_offset = 1 + ad2y_dim1;
    ad2y -= ad2y_offset;
    ady_dim1 = *m;
    ady_offset = 1 + ady_dim1;
    ady -= ady_offset;
    ay_dim1 = *m;
    ay_offset = 1 + ay_dim1;
    ay -= ay_offset;

    /* Function Body */
    switch (*s) {
	case 1:  goto L10;
	case 2:  goto L30;
    }

/* --------SAVING CHEBYSHEV COEFFICIENTS FOR  COORDINATES, */
/* --------     VELOCITY COMPONENTS AND ACCELERATION COMPONENTS */
/* ---------             AT THE FIRST INTERVAL */

L10:
    i__1 = *kp3;
    for (i__ = 1; i__ <= i__1; ++i__) {
	first_1.ay1[i__ - 1] = ay[i__ * ay_dim1 + 1];
/* L15: */
	first_1.ay2[i__ - 1] = ay[i__ * ay_dim1 + 2];
    }

    i__1 = *kp2;
    for (i__ = 1; i__ <= i__1; ++i__) {
	first_1.av1[i__ - 1] = ady[i__ * ady_dim1 + 1];
/* L20: */
	first_1.av2[i__ - 1] = ady[i__ * ady_dim1 + 2];
    }

    i__1 = *kp1;
    for (i__ = 1; i__ <= i__1; ++i__) {
	first_1.aw1[i__ - 1] = ad2y[i__ * ad2y_dim1 + 1];
/* L25: */
	first_1.aw2[i__ - 1] = ad2y[i__ * ad2y_dim1 + 2];
    }

/* --------SAVING COORDINATES AND VELOCITY AT THE END OF 1 INTERVAL */
    first_1.ya[0] = y[1];
    first_1.ya[1] = y[2];
    first_1.va[0] = dy[1];
    first_1.va[1] = dy[2];

/* --------SAVING BOUNDARIES OF 1 INTERVAL */
    first_1.ina[0] = *xi;
    first_1.ina[1] = *xe;
    return 0;

/* --------SAVING CHEBYSHEV COEFFICIENTS FOR  COORDINATES, */
/* --------     VELOCITY COMPONENTS AND ACCELERATION COMPONENTS */
/* ------------           AT THE SECOND INTERVAL */

L30:
    i__1 = *kp3;
    for (i__ = 1; i__ <= i__1; ++i__) {
	second_1.by1[i__ - 1] = ay[i__ * ay_dim1 + 1];
/* L35: */
	second_1.by2[i__ - 1] = ay[i__ * ay_dim1 + 2];
    }

    i__1 = *kp2;
    for (i__ = 1; i__ <= i__1; ++i__) {
	second_1.bv1[i__ - 1] = ady[i__ * ady_dim1 + 1];
/* L40: */
	second_1.bv2[i__ - 1] = ady[i__ * ady_dim1 + 2];
    }

    i__1 = *kp1;
    for (i__ = 1; i__ <= i__1; ++i__) {
	second_1.bw1[i__ - 1] = ad2y[i__ * ad2y_dim1 + 1];
/* L45: */
	second_1.bw2[i__ - 1] = ad2y[i__ * ad2y_dim1 + 2];
    }

/* --------SAVING COORDINATES AND VELOCITY AT THE END OF 2 INTERVAL */
    second_1.yb[0] = y[1];
    second_1.yb[1] = y[2];
    second_1.vb[0] = dy[1];
    second_1.vb[1] = dy[2];

/* --------SAVING BOUNDARIES OF 2 INTERVAL */
    second_1.inb[0] = *xi;
    second_1.inb[1] = *xe;
    return 0;
} /* f2trea_c */

